//+------------------------------------------------------------------+ 
//|  _TRO_Multi_Meter_HA                                             | 
//|                                                                  | 
//|   Copyright  2007, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFT AND DONATIONS ACCEPTED                                    | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 
#property indicator_chart_window

extern bool Show_Heading = true;
 
extern string IndName = "HA" ; // change


//*******************
extern bool Corner_of_Chart_RIGHT_TOP = true;

extern int Shift_UP_DN =25;
extern int Adjust_Side_to_side  = 5;

extern color BarLabel_color = LightBlue;
extern color CommentLabel_color = LightBlue;

//******************* 
// change inputs for your indicator 

string    HA_Settings          = "=== HA Settings ===";
extern int MaMetod   = 2;
extern int MaPeriod  = 6;
extern int MaMetod2  = 3;
extern int MaPeriod2 = 2;
extern double Level5 =  95 ;
extern double Level4 =  80 ;
extern double Level3 =  50 ;
extern double Level2 =  20 ;
extern double Level1 =  5 ;
extern double Level0 =  0 ;

extern color colorLevel5 =  Red ;
extern color colorLevel4 =  Orange ;
extern color colorLevel3 =  Yellow  ;
extern color colorLevel2 =  YellowGreen ;
extern color colorLevel1 =  Blue ;
extern color colorLevel0 =  Red;

//*******************


string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009;  

//+---------------

int fHA( int prd )
{

int HAval ;
double haOpen;
double haClose;

haOpen = iCustom(NULL,prd,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,2,0) ;
haClose = iCustom(NULL,prd,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,3,0) ;

if (haOpen<haClose) HAval = -1; else HAval = 1;

return ( HAval ) ;
} 
      
//+---------------

color MeterColor( double HAmeter )
{
if( HAmeter > Level5 ) { return( colorLevel5 ); } 
if( HAmeter > Level4 ) { return( colorLevel4 ); } 
if( HAmeter > Level3 ) { return( colorLevel3 ); } 
if( HAmeter > Level2 ) { return( colorLevel2 ); } 
if( HAmeter > Level1 ) { return( colorLevel1 ); } 
return( colorLevel0 );  
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 


//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
   //***********************************************************************************************************************

string LabelTime="";

if (LabelTime=="") {LabelTime=TimeToStr(TimeLocal(),TIME_SECONDS); }

   int    counted_bars=IndicatorCounted();
   
if ( Show_Heading) {         
    if (Corner_of_Chart_RIGHT_TOP == true)
    {  
    
   Obj0001 = "Numbers" + LabelTime ; 
           ObjectCreate(Obj0001, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0001, "M1  M5 M15 M30 H1  H4  D1 ", 6, "Tahoma Narrow", BarLabel_color);
   ObjectSet(Obj0001, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0001, OBJPROP_XDISTANCE, 12+Adjust_Side_to_side);
   ObjectSet(Obj0001, OBJPROP_YDISTANCE, 35+Shift_UP_DN); 
   }
    if (Corner_of_Chart_RIGHT_TOP == false)
   { 
           ObjectCreate(Obj0001, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0001, "  M1  M5  M15 M30  H1  H4  D1", 6, "Tahoma Narrow", BarLabel_color);
   ObjectSet(Obj0001, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0001, OBJPROP_XDISTANCE, 17+Adjust_Side_to_side);
   ObjectSet(Obj0001, OBJPROP_YDISTANCE, 24+Shift_UP_DN); 
    } 
} // Show_Heading

 //*******************   change for  your indicator ********************
   //HA Signals

   

    
    string M1_HA= "",M5_HA= "", M15_HA= "", M30_HA= "", H1_HA= "", H4_HA= "", D1_HA= "",PRC1;
    color  color_HAm1,color_HAm5,color_HAm15,color_HAm30,color_HAm60,color_HAm240,color_HAm1440;     

   double HA_1=fHA(PERIOD_M1);
   
   double HA_5=fHA(PERIOD_M5);
  
   double HA_15=fHA(PERIOD_M15);
     
   double HA_30=fHA(PERIOD_M30);
      
   double HA_60=fHA(PERIOD_H1);
    
   double HA_240=fHA(PERIOD_H4);
  
   double HA_1440=fHA(PERIOD_D1);
          
    
M1_HA = "-"; color_HAm1    = MeterColor( HA_1 ) ;
M5_HA = "-"; color_HAm5    = MeterColor( HA_5 ) ;
M15_HA= "-"; color_HAm15   = MeterColor( HA_15 ) ;
M30_HA= "-"; color_HAm30   = MeterColor( HA_30) ;
H1_HA = "-"; color_HAm60   = MeterColor( HA_60) ;
H4_HA = "-"; color_HAm240  = MeterColor( HA_240) ;
D1_HA = "-"; color_HAm1440 = MeterColor( HA_1440) ;
    

   Obj0002 = "SignalHAM1t" + LabelTime ; 
           
           ObjectCreate(Obj0002, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0002,IndName, 7, "Tahoma Narrow",  BarLabel_color);  
   ObjectSet(Obj0002, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0002, OBJPROP_XDISTANCE, 120+Adjust_Side_to_side);
   ObjectSet(Obj0002, OBJPROP_YDISTANCE, 50+Shift_UP_DN);  

   Obj0003 = "SignalHAM1" + LabelTime ;        
           ObjectCreate(Obj0003, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0003, M1_HA, 35, "Tahoma Narrow",  color_HAm1);
   ObjectSet(Obj0003, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0003, OBJPROP_XDISTANCE, 100+Adjust_Side_to_side);
   ObjectSet(Obj0003, OBJPROP_YDISTANCE, 25+Shift_UP_DN); 

   Obj0004 = "SignalHAM5" + LabelTime ;          
           ObjectCreate(Obj0004, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0004, M5_HA, 35, "Tahoma Narrow",  color_HAm5);
   ObjectSet(Obj0004, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0004, OBJPROP_XDISTANCE, 85+Adjust_Side_to_side);
   ObjectSet(Obj0004, OBJPROP_YDISTANCE, 25+Shift_UP_DN); 
      
   Obj0005 = "SignalHAM15" + LabelTime ; 
   ObjectCreate(Obj0005, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0005, M15_HA, 35, "Tahoma Narrow",  color_HAm15);
   ObjectSet(Obj0005, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0005, OBJPROP_XDISTANCE, 70+Adjust_Side_to_side);
   ObjectSet(Obj0005, OBJPROP_YDISTANCE, 25+Shift_UP_DN); 
      
   Obj0006 = "SignalHAM30" + LabelTime ; 
   ObjectCreate(Obj0006, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0006, M30_HA, 35, "Tahoma Narrow",  color_HAm30);
   ObjectSet(Obj0006, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0006, OBJPROP_XDISTANCE, 55+Adjust_Side_to_side);
   ObjectSet(Obj0006, OBJPROP_YDISTANCE, 25+Shift_UP_DN); 

   Obj0007 = "SignalHAM60" + LabelTime ;      
           ObjectCreate(Obj0007, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0007, H1_HA, 35, "Tahoma Narrow",  color_HAm60);
   ObjectSet(Obj0007, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0007, OBJPROP_XDISTANCE, 40+Adjust_Side_to_side);
   ObjectSet(Obj0007, OBJPROP_YDISTANCE, 25+Shift_UP_DN); 

   Obj0008 = "SignalHAM240" + LabelTime ;          
           ObjectCreate(Obj0008, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0008, H4_HA, 35, "Tahoma Narrow",  color_HAm240);
   ObjectSet(Obj0008, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0008, OBJPROP_XDISTANCE, 25+Adjust_Side_to_side);
   ObjectSet(Obj0008, OBJPROP_YDISTANCE, 25+Shift_UP_DN);

   Obj0009 = "SignalHAM1440" + LabelTime ;    
           ObjectCreate(Obj0009, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0009, D1_HA, 35, "Tahoma Narrow",  color_HAm1440);
   ObjectSet(Obj0009, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0009, OBJPROP_XDISTANCE, 10+Adjust_Side_to_side);
   ObjectSet(Obj0009, OBJPROP_YDISTANCE, 25+Shift_UP_DN);
  
 //----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
ObjectsDeleteAll(0,OBJ_HLINE);
ObjectsDeleteAll(0,OBJ_TEXT);
ObjectsDeleteAll(0,OBJ_LABEL);
deleteObject();  

//----
   return(0);
  }
  
void deleteObject()
  { 
ObjectDelete(Obj0001);  
ObjectDelete(Obj0002); 
ObjectDelete(Obj0003); 
ObjectDelete(Obj0004); 
ObjectDelete(Obj0005); 
ObjectDelete(Obj0006); 
ObjectDelete(Obj0007); 
ObjectDelete(Obj0008); 
ObjectDelete(Obj0009); 
 
  }
  
  